Subject: Re: bug#28795: 25.2; UTF-8 language environment causes extreme sluggishness

From: Eli Zaretskii <[email-masked]>
Date: Thu, 12 Oct 2017 13:00:23 +0300

[Please keep the bug address on the CC list.]

> From: Mark Laws <[email-masked]>
> Date: Thu, 12 Oct 2017 18:40:25 +0900
> 
> On Thu, Oct 12, 2017 at 6:31 PM, Eli Zaretskii <[email-masked]> wrote:
> >> From: Mark Laws <[email-masked]>
> >> Date: Thu, 12 Oct 2017 18:15:53 +0900
> >>
> >> M-x set-language-environment UTF-8
> >
> > On Windows, doing this is a mistake (but not because it causes
> > sluggish redisplay).
> 
> What is the correct way to use UTF-8 as the default encoding for
> things like file-visiting buffers without causing other potential
> problems?

Put this in your .emacs:

  (prefer-coding-system 'utf-8)

or even

  (setq-default buffer-file-coding-system 'utf-8-dos)

(the latter doesn't affect process I/O).

> > I cannot reproduce this here.  What font is used to display that
> > character?  You can find this out with "C-u C-x =" with the cursor on
> > the character.
> 
> uniscribe:-outline-PragmataPro
> Mono-normal-normal-normal-mono-15-*-*-*-c-*-iso8859-1 (#x8FC)

And which font is used if you don't set your language-environment to
UTF-8?

> If it doesn't work for you off the bat, do this after inserting the character:
> 
> M-: (put-text-property 1 2 'face font-lock-warning-face)
> 
> Then try moving around again.

Doesn't change anything here.

I do see slow redisplay on another system, where Symbola is not
installed, and the BatangChe font is then used.  But there I see slow
redisplay whether or not I set the language-environment to UTF-8.

> > On my system, I have the Symbola font installed, which is used for
> > displaying this character, and the problem doesn't happen.
> >
> > As another thing to try, set inhibit-compacting-font-caches to a
> > non-nil value, and see if that helps.
> 
> This seems to help

By "this" do you mean installing Symbola or setting
inhibit-compacting-font-caches non-nil?

> though the fact it only happens due to changes with encoding and/or
> font locking makes me suspicious.

It could be that the default language-environment causes a different
font to be used for that character.